Socialist = LibStub("AceAddon-3.0"):NewAddon("Babel")

--------------------------------------------------------------------------------
--                            VARIABLE INITIALIZE                             --
--------------------------------------------------------------------------------

Socialist.initialized = false

local database_defaults = {
	realm = {
		whodb = {
			["next id"] = 1,
		},
		groupdb = {
			["next id"] = 1,
		},
		profdb = {
			["next id"] = 1,
		},
	},
	profile = {

	},
}

--------------------------------------------------------------------------------
--                                   SETUP                                    --
--------------------------------------------------------------------------------

function Socialist:OnIntialize()
	self.db = LibStub("AceDB-3.0"):New("SocialistDB", database_defaults,
	    true)
	self.whodb = self.db.realm.whodb
	self.groupdb = self.db.realm.groupdb
	self.profdb = self.db.realm.profdb

	self.initialized = true
end

function Socialist:OnEnable()

end

--------------------------------------------------------------------------------
--                                    API                                     --
--------------------------------------------------------------------------------


--[[ Miscellaneous Functions ]]--

function Socialist:ClearDB(database)
	if not self.initialized then return end
	if not database == "whodb" and
	   not database == "groupdb" and
	   not database == "profdb" then return end
	self.db.realm[database] = {}
end

--[[ WhoDB Functions ]]--

function Socialist:WhoDB_GetRecordByID(id)
	if not self.initialized then return end
	if not type(id) == "number" then return end
	if self.whodb["next id"] <= id then return end
	for k,v in ipairs(self.whodb) do
		if v.id == id then
			return v
		end
	end
end

function Socialist:WhoDB_Query(query,sort,order)
	if not self.initialized then return end

end

function Socialist:WhoDB_Modify(id,zone,info)
	if not self.initialized then return end

end

function Socialist:WhoDB_CreateNewPlayer(name,zone,info)
	if not self.initialized then return end

end

function Socialist:WhoDB_Remove(id)
	if not self.initialized then return end

end

--[[ GroupDB Functions ]]--
function Socialist:GroupDB_GetRecordByID(groupid)
	if not self.initialized then return end

end

function Socialist:GroupDB_Query(query)
	if not self.initialized then return end

end

function Socialist:GroupDB_Modify(groupid,info)
	if not self.initialized then return end

end

function Socialist:GroupDB_CreateNewGroup()
	if not self.initialized then return end

end

function Socialist:GroupDB_Remove(groupid)
	if not self.initialized then return end

end

function Socialist:GroupDB_AddPlayer(groupid,id)
	if not self.initialized then return end

end

function Socialist:GroupDB_AddRaidID(groupid,raidid)
	if not self.initialized then return end

end

function Socialist:GroupDB_AddInstance(groupid,instance)
	if not self.initialized then return end

end

--[[ ProfDB Functions ]]--
function Socialist:ProfDB_GetRecordByID(profid)
	if not self.initialized then return end

end

function Socialist:ProfDB_Query(query,sort,order)
	if not self.initialized then return end

end

function Socialist:ProfDB_Modify(profid,info)
	if not self.initialized then return end

end

function Socialist:ProfDB_Remove(profid)
	if not self.initialized then return end

end

function Socialist:ProfDB_CreateNewRecipe(name,info)
	if not self.initialized then return end

end

function Socialist:ProfDB_AddIngredient(profid,name,amount)
	if not self.initialized then return end

end

function Socialist:ProfDB_AddCrafter(profid,id)
	if not self.initialized then return end

end

